#pragma once

#include <boost/filesystem/path.hpp> // for path
#include <fstream>                   // for ofstream
#include <memory>                    // for shared_ptr
#include <string>                    // for string

namespace caosdb::transaction {

class FileWriter final {
public:
  FileWriter(boost::filesystem::path filename);

  ~FileWriter() = default;

  FileWriter(const FileWriter &) = delete;
  FileWriter &operator=(const FileWriter &) = delete;

  FileWriter(FileWriter &&) = default;
  FileWriter &operator=(FileWriter &&) = default;

  void write(const std::string &buffer);

private:
  void openFile();

  std::ofstream stream_;
  boost::filesystem::path filename_;
};

} // namespace caosdb::transaction
