#pragma once
#include "caosdb/entity/v1alpha1/main.grpc.pb.h" // for FileTransmissionS...
#include "caosdb/entity/v1alpha1/main.pb.h"      // for FileDownloadResponse
#include "caosdb/handler_interface.h"            // for HandlerTag, Handl...
#include "caosdb/unary_rpc_handler.h"
#include <grpcpp/impl/codegen/async_unary_call.h> // for ClientAsyncRespons...
#include <grpcpp/impl/codegen/completion_queue.h> // for CompletionQueue
#include <memory>                                 // for unique_ptr

namespace caosdb::transaction {

using caosdb::entity::v1alpha1::FileTransmissionService;
using caosdb::entity::v1alpha1::RegisterFileUploadRequest;
using caosdb::entity::v1alpha1::RegisterFileUploadResponse;

class RegisterFileUploadHandler final : public UnaryRpcHandler {
public:
  RegisterFileUploadHandler(HandlerTag tag, FileTransmissionService::Stub *stub,
                            grpc::CompletionQueue *completion_queue,
                            RegisterFileUploadRequest *request,
                            RegisterFileUploadResponse *response);

  ~RegisterFileUploadHandler();

  RegisterFileUploadHandler(const RegisterFileUploadHandler &) = delete;
  RegisterFileUploadHandler &
  operator=(const RegisterFileUploadHandler &) = delete;
  RegisterFileUploadHandler(RegisterFileUploadHandler &&) = delete;
  RegisterFileUploadHandler &operator=(RegisterFileUploadHandler &&) = delete;

protected:
  void handleNewCallState() override;
  void handleReceivingFileState() override;

  HandlerTag tag_;

  FileTransmissionService::Stub *stub_;

  std::unique_ptr<grpc::ClientAsyncResponseReader<RegisterFileUploadResponse>>
    rpc_;

  RegisterFileUploadRequest *request_;
  RegisterFileUploadResponse *response_;
};

} // namespace caosdb::transaction
